ALTER SESSION SET NLS_DATE_FORMAT = 'YYYY-MM-DD';

CREATE TABLE EMPLOYEE(
	ID VARCHAR(8 CHAR) PRIMARY KEY,
	USERNAME VARCHAR2(50 CHAR) UNIQUE NOT NULL,
	PASSWORD VARCHAR2(64 CHAR) NOT NULL,
	FIRST_NAME VARCHAR2(25 CHAR) NOT NULL,
	LAST_NAME VARCHAR2(25 CHAR) NOT NULL,
	MIDDLE_NAME VARCHAR2(25 CHAR) NOT NULL,
	DATE_OF_BIRTH VARCHAR2(10 CHAR) NOT NULL,
	EMAIL VARCHAR2(50 CHAR) NOT NULL,
	PHONE_NUMBER VARCHAR2(10 CHAR) NOT NULL,
	IS_MANAGER CHAR(1) NOT NULL
);

CREATE TABLE REIMBURSEMENT_REQUEST(
	ID NUMBER(38) PRIMARY KEY,
	EMPLOYEE_ID VARCHAR(8 CHAR) NOT NULL REFERENCES EMPLOYEE,
	MANAGER_ID VARCHAR(8 CHAR) REFERENCES EMPLOYEE,
	DATE_MADE VARCHAR2(10 CHAR) NOT NULL,
	DATE_RESOLVED VARCHAR2(10 CHAR),
	DESCRIPTION VARCHAR(256 CHAR),
	CATEGORY VARCHAR(16 CHAR) NOT NULL,
	COST NUMBER(19, 4) NOT NULL,
	APPROVED CHAR(1) DEFAULT 'N' NOT NULL
);

----------------------------------------------------------
--
----------------------------------------------------------

CREATE SEQUENCE SQ_REIMBURSEMENT_REQUEST_ID
START WITH 1
INCREMENT BY 1;

----------------------------------------------------------
--
----------------------------------------------------------


CREATE OR REPLACE TRIGGER TR_INSERT_REIMBURSEMENT_REQUEST_ID
BEFORE INSERT ON REIMBURSEMENT_REQUEST
FOR EACH ROW 
BEGIN 
		SELECT SQ_REIMBURSEMENT_REQUEST_ID.NEXTVAL INTO :NEW.ID FROM DUAL;
END;